;angular.module('Landers.angular')
    .directive('dropSelect', ['Flat', function(Flat) {
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs){
                var $button = $ele.find('.dropdown-toggle');
                var $list = $ele.find('.dropdown-menu');

                var init_event = $attrs['dropSelectInit'];
                init_event = Flat.get($scope, init_event);
                if (init_event) init_event();

                var change_event = $attrs['dropSelectChange'];
                change_event = Flat.get($scope, change_event);
                if (change_event) {
                    (function(){
                        var self = arguments.callee;
                        var $items = $list.children('li');
                        if ($items.length) {
                            $items.on('click', function(){
                                change_event($(this));
                            });
                        } else {
                            setTimeout(self, 300);
                        }
                    })();
                }
            }
        };
    }]);