;angular.module('Landers.angular')
    .directive('keyToText', ['$timeout', 'Flat', function($timeout, Flat) {
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs) {
                var arr = $attrs['keyToText'].split('|');
                var _enums = Flat.get($scope, arr[0]), enums = {};
                if ( angular.isArray(_enums)) {
                    _enums.map(function(item){
                        enums[item.key] = {
                            text: item.text
                        };
                    });
                } else {
                    enums = _enums;
                }

                var monitorKey = arr[1];
                var textField = arr[2] ? arr[2] : 'text';
                var listener = function(newValue) {
                    var data = enums[newValue];
                    if (!data) return;

                    var html = data[textField] || data.text;
                    var $text = $ele.find('.key-to-text');
                    if ($text.length) $text.html(html);
                    else $ele.html(html);

                    if (!data._class) return;
                    for (var k in enums) $ele.removeClass(enums[k]['_class']);
                    $ele.addClass(data._class);
                };
                var monitorVal = monitorKey.match(/\[(.*)\]/);
                if (monitorVal) {
                    $scope.$watch( function(){return monitorVal[1];}, listener);
                } else {
                    $scope.$watch( monitorKey, listener);
                }
            }
        };
    }]);