;angular.module('Landers.angular')
    .directive('disabledWhen', ['$compile', 'Runtime', 'Helpers', function($compile, Runtime, Helpers){
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs) {
                var myScope = Helpers.seekScope($scope, $attrs['useScope']);

                var datkey = $attrs['disabledWhen'];
                var runtime = Runtime.make(myScope);
                var cache = runtime.get('watchers') || {};

                if ( cache[datkey] ) {
                    cache[datkey].push($ele);
                    runtime.set('watchers', cache);
                } else {
                    cache[datkey] = [$ele];
                    runtime.set('watchers', cache);
                }

                myScope.$watch(datkey, function(newValue){
                    cache[datkey].map(function($e){
                        if (newValue) $e.addClass('disabled').prop('disabled', true);
                        else $e.removeClass('disabled').prop('disabled', false);
                    });
                });
            }
        };
    }]);