;angular.module('Landers.angular')
    .directive('landersUpload', ['Flat', '$compile', function(Flat, $compile) {
        return {
            restrict : 'A',
            link : function($scope, $ele, $attrs) {
                var ng_model = $attrs['ngModel'];
                var html = '<textarea ng-model="' + ng_model + '" class="wp100 h100 mb10" style="display:none"></textarea>';
                $input = $($compile(html)($scope)).appendTo($ele);

                var key = $attrs['uploadKey'];
                var options = $attrs['uploadOptions'];
                options = Landers.utils.str.replace(options, "'", '"');
                options = angular.fromJson(options);

                options.onUploaded = options.onUploaded ? Flat.get($scope, options.onUploaded) : undefined;
                options.onRemove = options.onRemove ? Flat.get($scope, options.onRemove) : undefined;
                options.onDeleted = options.onDeleted ? Flat.get($scope, options.onDeleted) : undefined;

                var on_changed = options.onChanged ? Flat.get($scope, options.onChanged) : undefined;

                options.onChanged = function(data){
                    Flat.set($scope, ng_model, data);
                    if (!$scope.$$phase) $scope.$apply();
                    on_changed && on_changed( data );
                };

                var upload = new Landers.upload($ele, $input, key, options);
                var watcher = $scope.$watch( ng_model, function(new_value){
                    if ( !new_value ) return;
                    if ( angular.isObject(new_value)) {
                        // 监控到一次，即可停止监控
                        watcher();

                        upload.setInput(new_value);
                        upload.show();
                    }
                });
            }
        };
    }]);