;angular.module('Landers.angular')
    .factory('Helpers', ['Flat', function(Flat){
        return {
            seekScope : function(scope, parentId) {
                var myScope = scope;
                if ( !parentId) return myScope;
                while (myScope.$id != parentId) {
                    if (myScope.$parent) {
                        myScope = myScope.$parent;
                    } else {
                        break;
                    }
                }
                return myScope;
            },
            toJqEle : function($event) {
                if (!$event) return $();
                var obj = angular.isElement($event) ? $event : $event.target;
                return angular.element(obj);
            },
            disable : function($event){
                $event = this.toJqEle($event);
                return Landers.helpers.disable($event);
            },
            enable : function($event) {
                $event = this.toJqEle($event);
                return Landers.helpers.enable($event);
            },
            domainUrl : function(domainUrl, url) {
                if (!domainUrl) return url;
                var len = domainUrl.length;
                var pre = Landers.utils.str.left(url, len);
                if (pre === domainUrl) return url;
                else return domainUrl + url;
            }
        };
    }]);