;angular.module('Landers.angular')
    .factory('Runtime', ['Flat', function (Flat) {
        var cache = {};
        function runtime (scope){
            var prekey = '$runtime';
            if ( !cache[scope.$id] ) {
                scope.$runtime = {};
                cache[scope.$id] = true;
            }
            this.__proto__ = Flat.make(scope[prekey], scope);
            this.watch = function(key, callback){
                key = prekey + '.' + key;
                return scope.$watch(key, callback);
            };
        }
        return {
            make:function(scope){
                return new runtime(scope);
            }
        };
    }]);