;angular.module('Landers.angular')
    .provider('GNotify', function(){
        var provider = this;
        provider.config = {
            startTop: 60,
            // templateUrl: '',
            position: 'right',
            duration: 10000
        };

        provider.events = [];

        Landers.css.add('.notify-box {min-width: 200px}');

        provider.classes = ['notify-box', 'text-left', 'alert'];

        this.$get = ['$rootScope', 'notify', function($rootScope, notify) {
            return {
                initConfig: function(opts){
                    notify.config(angular.extend(provider.config, opts || {}));
                },

                response: function(rspn, opts){
                    this.initConfig(opts);

                    var classes = provider.classes.slice(0);
                    if ( rspn.success === true ) classes.push('alert-success');
                    else if ( rspn.success === false ) classes.push('alert-danger');
                    else classes.push('alert-info');

                    notify({
                        classes: classes.join(' '),
                        message: rspn.message
                    });
                },

                startlisten: function(){
                    var _this = this;
                    provider.events.map(function(event){
                        $rootScope.$on(event, function($event, rspn){
                            _this.response(rspn);
                        });
                    })
                }
            };
        }];
    });